#define GAME_DLL

#include "GMLuaModule.h"

#include <cbase.h>

GMOD_MODULE(Load, Unload);

ILuaInterface *gLua = NULL;

IVEngineServer *engine = NULL;

int GetPlayerEIndex(ILuaObject *playerEntity)
{
	ILuaObject *entityMT = gLua->GetMetaTable("Entity", GLua::TYPE_ENTITY);
		entityMT->GetMember("EntIndex")->Push();

		playerEntity->Push();

		gLua->Call(1, 1);
	entityMT->UnReference();

	return (gLua->GetReturn(0)->GetInt());
}

LUA_FUNCTION(ExecuteCommand)
{
	gLua->CheckType(1, GLua::TYPE_ENTITY);
	gLua->CheckType(2, GLua::TYPE_STRING);

	edict_t* playerEdict = engine->PEntityOfEntIndex(GetPlayerEIndex(gLua->GetObject(1)));

	if (playerEdict)
		engine->ClientCommand(playerEdict, gLua->GetString(2));

	return 0;
}

int Load(lua_State *L)
{
	gLua = Lua();
		
	CreateInterfaceFn engineFactory = Sys_GetFactory("engine.dll");

	engine = (IVEngineServer*)engineFactory(INTERFACEVERSION_VENGINESERVER, NULL);

	ILuaObject *playerMT = gLua->GetMetaTable("Player", GLua::TYPE_ENTITY);
		playerMT->SetMember("ExecuteCommand", ExecuteCommand);
	playerMT->UnReference();

	return 0;
}

int Unload(lua_State *L)
{
	return 0;
}